function love.load()
	require "levels/dungeon_1" --includes the lvls(dungeons)
	require "json"
	boss_1 = love.graphics.newImage("graphics/boss_1.png")
	guy_d = love.graphics.newImage("graphics/Player_D.png") --1 (Directional Graphics)
	guy_u = love.graphics.newImage("graphics/Player_U.png") --2 (Directional Graphics)
	guy_l = love.graphics.newImage("graphics/Player_L.png") --3 (Directional Graphics)
	guy_r = love.graphics.newImage("graphics/Player_R.png") --4 (Directional Graphics)
	flor= love.graphics.newImage("graphics/Floor.png") --0 (on map) (Should be floor but, whatever)
	wall= love.graphics.newImage("graphics/Wall.png") --1 (on map)
	checkpoint= love.graphics.newImage("graphics/Stairs_down.png") --2 (on map)
	decheck= love.graphics.newImage("graphics/Stairs_down.png") --3 (on map)
	chest= love.graphics.newImage("graphics/Chest.png") --4 (on map)
	battle= love.graphics.newImage("battle/Background.png")
    player = { --Assigns stuff to player. 1(exept for background) is true, 0 is false
        grid_x = 256,
        grid_y = 256,
        act_x = 200,
        act_y = 200,
        speed = 10,
		direction = 1,
		health = 100,
		sword = 1,
		shield = 0,
		level=1,
		xp = 0,
		death = false
    }
    deathtext = 'GAME OVER'
	--Checks if the file exists
	if not love.filesystem.exists("dungeon.txt") then
    --If not, then create a new one.
    love.filesystem.newFile("dungeon.txt")
	love.filesystem.write("dungeon.txt", json.encode(player))
	end
	--Load the save file state
	
	level_load() --Loads lvl
	monster=math.random()
	mon=0
	v=0.0008
end

function love.update(dt)

	if player.health==0 then
		player.death = true
	end

	if gameIsPaused then return end --Pauses the game when not focused
    player.act_y = player.act_y - ((player.act_y - player.grid_y) * player.speed * dt) --Sets the player's x
    player.act_x = player.act_x - ((player.act_x - player.grid_x) * player.speed * dt) --Sets the player's y
	fps = love.timer.getFPS()
end

function love.focus(f)
gameIsPaused = not f
end

function love.draw()
    love.graphics.print("This is the help for this game.\nUse the arrow keys the control the player.\nUse L to load. You save when you exit the game.\nAlpha v."..v.."\n\n\n\nDebugging Info:\nFPS:"..fps.."\nRandom:"..monster.."\nMonsters(True/False):"..mon.."\nHealth:"..player.health.."\nSword(True/False):"..player.sword.."\nXp:"..player.xp.."", 500, 30) --help
   for y=1, #map do --draws the map
        for x=1, #map[y] do
            if map[y][x] == 1 then
                love.graphics.draw(wall, x * 32 , y * 32)
            end
            if map[y][x] == 2 then
                love.graphics.draw(checkpoint, x * 32 , y * 32 )
            end
            if map[y][x] == 3 then
                love.graphics.draw(decheck, x * 32 , y * 32 )
            end
            if map[y][x] == 0 then
                love.graphics.draw(flor, x * 32 , y * 32 )
            end
            if map[y][x] == 4 then
                love.graphics.draw(chest, x * 32 , y * 32 )
            end
            if map[y][x] == 5 then
                love.graphics.draw(boss_1, x * 32 , y * 32 )
            end
        end
    end
	if player.direction==1 then --prints the direction of player
		love.graphics.draw(guy_u, player.act_x, player.act_y)
	elseif player.direction==2 then
		love.graphics.draw(guy_d, player.act_x, player.act_y)
	elseif player.direction==3 then
		love.graphics.draw(guy_l, player.act_x, player.act_y)
	elseif player.direction==4 then
		love.graphics.draw(guy_r, player.act_x, player.act_y)
	end
	
	if player.death then
		love.graphics.print(deathtext,500,300)
	end
end

function love.keypressed(key)
    if key=="up" then
        if testMap(0, -1) then
            player.grid_y = player.grid_y - 32
			player.direction=1 --Sets direction of player
			monster=math.random() --Generates a random number
				if monster>0.8 then --Check if you enchountered a monster
					mon=1
				else
					mon=0
	end
        end
    elseif key=="down" then
        if testMap(0, 1) then
            player.grid_y = player.grid_y + 32
			player.direction=2
			monster=math.random()
				if monster>0.8 then
					mon=1
				else
					mon=0
	end
		end
    elseif key=="left" then
        if testMap(-1, 0) then
            player.grid_x = player.grid_x - 32
			player.direction=3
			monster=math.random()
				if monster>0.8 then
					mon=1
				else
					mon=0
	end
        end
    elseif key=="right" then
        if testMap(1, 0) then
            player.grid_x = player.grid_x + 32
			player.direction=4
			monster=math.random()
				if monster>0.8 then
					mon=1
				else
					mon=0
    end
		end
	end
	if key=="l" then
		player = json.decode(love.filesystem.read("dungeon.txt"))
		level_load()
	end
end

function testMap(x, y) --Collisions
    if map[(player.grid_y / 32) + y][(player.grid_x / 32) + x] == 1 then
        return false
    end
	if map[(player.grid_y / 32) + y][(player.grid_x / 32) + x] == 2 then
		player.level = player.level + 1
		level_load()
		
        return true
    end
	if map[(player.grid_y / 32) + y][(player.grid_x / 32) + x] == 3 then
		player.level = player.level - 1
		level_load()
		
        return true
    end
    if map[(player.grid_y / 32) + y][(player.grid_x / 32) + x] == 4 then
        return false
    end
    if map[(player.grid_y / 32) + y][(player.grid_x / 32) + x] == 5 then
    	player.health = player.health - 50 --for testing purposes
        return false
    end
    return true
end

function love.quit()
  --Before quitting, save the new information to the savefile.
	love.filesystem.write("dungeon.txt", json.encode(player))
end